# Copyright 

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#

@@Author_and_Version = "Tool created by pgarmyn, Version 2011-06-02"
@@Toolname = "Random Texture Position"
# Description :   randomize texture position for all faces in the selection,
#                       including faces nested in groups
# Author :        pgarmyn
# Usage :         1.	Install into the plugins directory or into the 
#                 2.	Select faces, groups ....
#                 3.    ContextMenu  "Randomize Texture Position"                 
# Date :          2011-06-02
# Type :          Tool
# History:       Changing @@model.start_operation @@Toolname : without 2nd parameter for older SketchUp- versions
# Thanks to Lee3001 (Alex Lee ?) for the idea of point.push [rand(2048), rand(2048), rand(2048)]
#        used in his code rantexpos.rb

require 'sketchup.rb'


def randomTexture
        
        @@cnt=0
      	@@model=Sketchup.active_model
	@@model.start_operation @@Toolname ##,true ## 2nd argument not for older versions
	randTexture_ent(@@model.selection)
	@@model.commit_operation
	puts @@Toolname+" on "+@@cnt.to_s+" faces"
	puts @@Author_and_Version
end

def randTexture_ent(ents_in)
        tpoint = []
        for e in ents_in
                if e.class == Sketchup::Face
                        tpoint.push [rand(2048), rand(2048), rand(2048)] # Thanks to Lee3001
                        tpoint.push [0, 0, 0]
                        if e.material
                                if e.material.materialType > 0
                                        tx = e.material                                        
                                        e.position_material (tx, tpoint, true)
                                        @@cnt+=1  
                                end
                        end
                        if e.back_material
                                if e.back_material.materialType > 0
                                        tx = e.back_material
                                        e.position_material (tx, tpoint, false)
                                        @@cnt+=1  
                                end
                        end
                        tpoint.clear
                      
                elsif e.class == Sketchup::Group
                        e.make_unique if e.definition.count_instances > 1
                        randTexture_ent(e.entities)                 
                end
        end      
end



def randomTexture_validate_selection	
        return true if (Sketchup.active_model.selection.length > 0) 
	return nil
end


if( not file_loaded?("RandomTexturePosition.rb") )
	UI.add_context_menu_handler do |menu|
		if randomTexture_validate_selection
			menu.add_separator
			menu.add_item(@@Toolname) { randomTexture }	
		end

	end
end


file_loaded("RandomTexturePosition.rb")


